Download it now!
Bug 83534 - PIVOTTABLE: segfault creating PivotTable from Datasource registered
Summary: PIVOTTABLE: segfault creating PivotTable from Datasource registered
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.3.1.2 release
Hardware: Other Linux (All)
: high critical
Assignee: Markus Mohrhard
URL:
Whiteboard: BSA target:4.5.0 target:4.4.0.0.beta2...
Keywords: bibisected, haveBacktrace, regression
: 85589 87406 87454 88550 89397 (view as bug list)
Depends on:
Blocks:
 
Reported: 2014-09-05 16:00 UTC by Pierre HENAUT
Modified: 2016-01-20 11:01 UTC (History)
12 users (show)

See Also:
Crash report or crash signature:


Attachments
example database (3.57 KB, application/vnd.oasis.opendocument.database)
2014-09-05 21:56 UTC, Terrence Enger
Details
gdb on the core file, embedded FB (10.60 KB, text/plain)
2014-09-05 22:09 UTC, Terrence Enger
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Pierre HENAUT 2014-09-05 16:00:07 UTC
Calc Crashes when creating PivotTable from Datasource registered.

From a new ods sheet,

do :
1. Data -> Pivot Table -> Create
2. Select 'Data source registered in Libreoffice'
3. Connect to the base,user and password (the ODB is JDBC database connected to MySQL)
4. Select Data Source : I can select Query, I see the available queries

And I click 'OK'

Calc crashes ...
Using the F4 Navigator from Calc works, the data on MySQL are downloading

Best Regards.

Operating System: Ubuntu
Version: 4.3.1.2 release
Comment 1 Terrence Enger 2014-09-05 21:56:58 UTC
Created attachment 105821 [details]
example database

Whoops.  I see that I selected a table in "Select Data Source" dialog
where Pierre selected a query.  Nevertheless, I shall continue,
guessing that the crash is the same.


STR:

(1) Enable experimental features in LibreOffice.  This allows use of
    an embedded Firebird database, which allows a backtrace without
    JRE.

(2) Download the attached .odb and register it in LibreOffice.

(3) Run soffice with command line parameter --calc.  Program presents
    spreadsheet "Untitled 1".

(4) Take menu options Data > "Pivot table" > "Create...".  Program
    presents dialog "Select Source".

(5) Click radio button "Data Source registered in LibreOfficeDev" and
    click <OK>.  Program presents dialog "Select Data Source".

(6) In dialog "Select Data Source",
      - Database    : select embedded_FB
      - Data source : select Table1
      - Type        : select Sheet
    Click <OK>.  Program segfaults in ScAddress::ScAddress.


These observations are on master commit f74633, fetched 2014-08-23,
configured:
    --enable-option-checking=fatal --enable-dbgutil --enable-crashdump
    --without-system-postgresql --without-myspell-dicts
    --with-extra-buildid --without-doxygen
    --with-external-tar=/home/terry/lo_hacking/git/src
    --enable-online-update
built and running of debian-wheezy 64-bit.

As Pierre sees a crash with a JDBC connection to MySQL and I see
crashes with embedded Firebird and embedded HSQLDB, I conclude that
the crash is independent of the backend.

In the bibisect-43all repository, I used an embedded HSQLDB instead of
Firebird.  `git bisect` says:

    c08fd0a6e2cf014989732351c624bede765d2375 is the first bad commit
    commit c08fd0a6e2cf014989732351c624bede765d2375
    Author: Bjoern Michaelsen <bjoern.michaelsen@canonical.com>
    Date:   Mon May 12 06:03:39 2014 +0000

        source-hash-b850adf13ec8fad5f1e49c06fbb1d81a546b4636
    
        commit b850adf13ec8fad5f1e49c06fbb1d81a546b4636
        Author:     Caolán McNamara <caolanm@redhat.com>
        AuthorDate: Sun Mar 30 21:24:11 2014 +0100
        Commit:     Caolán McNamara <caolanm@redhat.com>
        CommitDate: Mon Mar 31 09:23:16 2014 +0100
    
            coverity#1194932 Uncaught exception
    
            Change-Id: Ia1811b7ec040887079d90ac611316983c1e77b03

    :100644 100644 2b97253caaebce49796158e46b92b962e5f4d0d6 bb736fb5752bda1bacc6ec276d7d3f7bd380f49c M	ccache.log
    :100644 100644 b5989981b23d9e35cef03404d359646680c3f53f ed5c673b198e035fc65a0bc578ad62f2c7ec6307 M	commitmsg
    :100644 100644 a705f30d0fbe6cd72efa42d0566f839ee864fc6e d7980b8aacbf0cc847fbb15e1f3b6a1103bf0ed5 M	make.log
    :040000 040000 d4928135aad07203259ca870a67ecf4e3dc9f6a4 8a7724d6975b56c9b75615ea793832896263d305 M	opt

and `git bisect log`:

    # bad: [894c969cde608547fda47917dbeeffdf7ebb4628] source-hash-7cc6de1cc2cfb466131072c2a1cd99c4a6279ebc
    # good: [9d57c189d74551d2b3770cc81139ea10a62e672f] source-hash-5b5e62650354788e50b44f32c22b687b2018aba9
    git bisect start '894c969' '9d57c18'
    # bad: [043d1114b660bf322c82b6d4af3d7a6decf410b6] source-hash-de0309581b2a539e8ccf370ff0f054a56dba1c11
    git bisect bad 043d1114b660bf322c82b6d4af3d7a6decf410b6
    # good: [c4e590b6482131576747491ef9e0a2f9be6071aa] source-hash-1ad901464afa29c96682bde59a12f864fccd525a
    git bisect good c4e590b6482131576747491ef9e0a2f9be6071aa
    # bad: [5f470f9cc992302f16a0ad8b2680725ad5beec08] source-hash-7c4783f6a2cb7598ecc48f20379dad9784541d5b
    git bisect bad 5f470f9cc992302f16a0ad8b2680725ad5beec08
    # bad: [c08fd0a6e2cf014989732351c624bede765d2375] source-hash-b850adf13ec8fad5f1e49c06fbb1d81a546b4636
    git bisect bad c08fd0a6e2cf014989732351c624bede765d2375
    # first bad commit: [c08fd0a6e2cf014989732351c624bede765d2375] source-hash-b850adf13ec8fad5f1e49c06fbb1d81a546b4636
Comment 2 Terrence Enger 2014-09-05 22:09:23 UTC
Created attachment 105822 [details]
gdb on the core file, embedded FB
Comment 3 Terrence Enger 2014-09-05 22:35:21 UTC
Looking at `git log 1ad90146..b850adf1`, I notice some mentions of
"pivot":

    commit e211e4ed41289fe680ac3d733175ef40a1e290b8
    Author: Tomaž Vajngerl <tomaz.vajngerl@collabora.com>
    Date:   Mon Mar 31 10:10:25 2014 +0200

        pivot layout dialog: remove SAL_OVERRIDE from destructors
    
        Change-Id: Icdb048a2ad9c49308213c3bb57f540e4ff567593

    commit e75f8d8e059bc293625dfa34e15b68eb6d820ac4
    Author: Tomaž Vajngerl <tomaz.vajngerl@collabora.com>
    Date:   Mon Mar 31 09:43:17 2014 +0200

        sc: clean-up pivot.hxx/pivot2.cxx
    
        Change-Id: I88ed4da8dd2ca026eeea4a3fb267f4f9954c180a

    commit 4f1f8b8e993b98095bf50c9e432fb0400d318b1f
    Author: Tomaž Vajngerl <tomaz.vajngerl@collabora.com>
    Date:   Sun Mar 30 21:12:27 2014 +0200

        pivot: new pivot table layout dialog
    
        This commit adds a new pivot table layout dialog which was implemented
        from scratch. Instead of custom controls this one uses list boxes
        for field entries which greatly reduces the code. It also fixes
        some visual and behaviour bugs and adds the possibility to edit the
        "Data" field.
    
        Change-Id: I6c01252acee5a2e8910e40e65904504d00e03057
Comment 4 Julien Nabet 2014-11-01 23:26:53 UTC
*** Bug 85589 has been marked as a duplicate of this bug. ***
Comment 5 Julien Nabet 2014-11-06 10:10:45 UTC
*** Bug 85589 has been marked as a duplicate of this bug. ***
Comment 6 Robinson Tryon (qubit) 2014-11-20 18:07:51 UTC
Removing comma from whiteboard (please use a space to delimit values in this field)
https://wiki.documentfoundation.org/QA/Bugzilla/Fields/Whiteboard#Getting_Started
Comment 7 Björn Michaelsen 2014-11-28 09:42:17 UTC
(This is an automated message.)

LibreOffice development currently prioritizes bugs with the so called MAB (most annoying bugs) -- as this bug has not run through that process (including writing a short rationale for this bug being a candidate and other who are watching the tracker bug silently approving that rationale etc.) its priority is set to high. Note this is effectively no change in the urgency assigned to this bug, as we are currently not making a difference between high and highest and severity is untouched.

You can find out more about MABs and how the process works by contacting libreoffice qa on irc:

 http://webchat.freenode.net/?channels=libreoffice-qa

The QA wiki page also gives you hints on how to get in contact with the team (if IRC fails you, your next best choice is the mailing list):

 https://wiki.documentfoundation.org/QA
Comment 8 Markus Mohrhard 2014-12-01 01:35:00 UTC
Please don't use blocker unless it is something that really needs to block the next release. In that case it would surely not be enough to mark the bug as blocker but also bring this bug immediately to the attention of the dev mailing list and the ESC.

This bug does not qualify as a blocker under this definition.
Comment 9 Alex Thurgood 2014-12-01 05:50:17 UTC
(In reply to Markus Mohrhard from comment #8)
> Please don't use blocker unless it is something that really needs to block
> the next release. In that case it would surely not be enough to mark the bug
> as blocker but also bring this bug immediately to the attention of the dev
> mailing list and the ESC.
> 
> This bug does not qualify as a blocker under this definition.

It would appear to under the guidelines for QA :

https://wiki.documentfoundation.org/Release_Criteria#Blocker_Bug_Definition

- most users of the function affected - yes ;
- unusable function - yes ;
- regression ;
- no reasonable workaround

In fact, pretty much what also qualifies for MAB.

So, as usual, it comes down to the individual QAer's interpretation of the guidelines, and a mismatch in expectations by the developer who has to / wants to fix it.

As to why a developer wasn't put on CC, well probably because QAer's have been warned off from putting devs directly on CC. Although I didn't open this report (I found the DUP in this case), one can hardly be surprised that neither the mailing list or a Calc dev were put on CC, given the poor reception most people get when they do that.
Comment 10 Joel Madero 2014-12-01 06:08:08 UTC
FWIW that wiki is outdated and needs updated - I'll add it to my todo list. Blockers are highly unusual (virtually non-existent). I need to get a list of every wiki page that suggests how to prioritize and clean them all once and for all so they are consistent.

IMHO: No bug should ever be placed as blocker unless first discussed by ESC - this does not mean that every person should ask ESC to address a ton of bugs - it should first go through QA meeting, then if determined that ESC is appropriate, Robinson can bring it up to ESC. We're not about strict rules or guidelines but for devs to trust the system, we have to be somewhat consistent and knowing that releases are pretty much never blocked (so BLOCKER is indeed....rare)
Comment 11 Commit Notification 2014-12-01 06:56:52 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=f1cdad3253730c593953b91279d17c8a4590fed9

For external data sources this variable can be null, fdo#83534

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2014-12-01 07:03:18 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=7ede454ecf9650a4d023e5eccd397f0991061df3&h=libreoffice-4-4

For external data sources this variable can be null, fdo#83534

It will be available in 4.4.0.0.beta2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 13 Markus Mohrhard 2014-12-01 07:04:47 UTC
4-3 review request is in gerrit
Comment 14 Commit Notification 2014-12-01 09:23:16 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=21de464632e653562f7a24f2a7285479fcfb0c7a&h=libreoffice-4-3

For external data sources this variable can be null, fdo#83534

It will be available in 4.3.6.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 15 Alex Thurgood 2014-12-17 12:00:09 UTC
*** Bug 87406 has been marked as a duplicate of this bug. ***
Comment 16 raal 2014-12-18 20:37:37 UTC
*** Bug 87454 has been marked as a duplicate of this bug. ***
Comment 17 raal 2015-01-18 10:02:31 UTC
*** Bug 88550 has been marked as a duplicate of this bug. ***
Comment 18 raal 2015-02-15 19:57:10 UTC
*** Bug 89397 has been marked as a duplicate of this bug. ***
Comment 19 Robinson Tryon (qubit) 2015-12-17 08:35:02 UTC
Migrating Whiteboard tags to Keywords: (bibisected)
[NinjaEdit]